searchNodes=[{"doc":"To format Surface code using Elixir 1.13 or later, use Surface.Formatter.Plugin.Formats Surface ~F sigils and .sface files in the given files and patterns.$ mix surface.format &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot; $ cat path/to/file.ex | mix surface.format -Takes the same options as mix format except for --check-equivalent.Formatting optionsLike mix format, the Surface formatter reads a .formatter.exs file in the current directory for formatter configuration. The Surface formatter accepts the same options as mix format. Read more about the expected format of .formatter.exs and the shared configuration options documented here.The Surface formatter also takes the following two additional options specified in .formatter.exs::surface_line_length overrides :line_length only for mix surface.format (:line_length is used otherwise, or defaults to 98):surface_inputs overrides :inputs only for mix surface.format (:inputs is used otherwise)Task-specific optionsThe Surface formatter accepts the same task-specific options as mix format. Read documentation for the options documented here..For quick reference, here are some examples of using these options:$ mix surface.format --check-formatted ** (Mix) mix surface.format failed due to --check-formatted. The following files are not formatted: * path/to/component.ex * path/to/file.sface$ mix surface.format --dry-run$ mix surface.format --dot-formatter path/to/.formatter.exsYou can also use the same syntax as mix format for specifying which files to format:$ mix surface.format path/to/file.ex &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot;","ref":"Mix.Tasks.Surface.Format.html","title":"Mix.Tasks.Surface.Format","type":"task"},{"doc":"Functions for formatting Surface code snippets.","ref":"Surface.Formatter.html","title":"Surface.Formatter","type":"module"},{"doc":"Formats the given Surface code string. (Typically the contents of an ~F sigil or .sface file.)In short:HTML/Surface elements are indented to the right of their parents.Attributes are split on multiple lines if the line is too long; otherwise on the same line.Elixir code snippets (inside { }) are ran through the Elixir code formatter.Lack of whitespace is preserved, so that intended behaviors are not removed. (For example, &lt;span&gt;Foo bar baz&lt;/span&gt; will not have newlines or spaces added.)Below the Options section is a non-exhaustive list of behaviors of the formatter.Options:line_length - the line length to aim for when formatting the document. Defaults to 98. As with the Elixir formatter, this value is used as reference but is not always enforced depending on the context.IndentationThe formatter ensures that children are indented one tab (two spaces) in from their parent.WhitespaceWhitespace that existsAs in regular HTML, any string of continuous whitespace is considered equivalent to any other string of continuous whitespace. There are four exceptions:Macro components (with names starting with #, such as &lt;#Markdown&gt;)&lt;pre&gt; tags&lt;code&gt; tags&lt;script&gt; tagsThe contents of those tags are considered whitespace-sensitive, and developers should sanity check after running the formatter.Whitespace that doesn't exist (Lack of whitespace)As is sometimes the case in HTML, lack of whitespace is considered significant. Instead of attempting to determine which contexts matter, the formatter consistently retains lack of whitespace. This means that the following&lt;div&gt;&lt;p&gt;Hello&lt;/p&gt;&lt;/div&gt;will not be changed. However, the following&lt;div&gt; &lt;p&gt; Hello &lt;/p&gt; &lt;/div&gt;will be formatted as&lt;div&gt; &lt;p&gt; Hello &lt;/p&gt; &lt;/div&gt;because of the whitespace on either side of each tag.To be clear, this example&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;will be formatted as&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;because of the lack of whitespace in between the opening and closing &lt;p&gt; tags and their child content.Splitting children onto separate linesIn certain scenarios, the formatter will move nodes to their own line:(Below, &quot;element&quot; means an HTML element or a Surface component.)If an element contains other elements as children, it will be surrounded by newlines.If there is a space after an opening tag or before a closing tag, it is converted to a newline.If a closing tag is put on its own line, the formatter ensures there's a newline before the next sibling node.Since SurfaceFormatter doesn't know if a component represents an inline or block element, it does not currently make distinctions between elements that should or should not be moved onto their own lines, other than the above rules.This allows inline elements to be placed among text without splitting them onto their own lines:The &lt;b&gt;Dialog&lt;/b&gt; is a stateless component. All event handlers had to be defined in the parent &lt;b&gt;LiveView&lt;/b&gt;.Newline charactersThe formatter will not add extra newlines unprompted beyond moving nodes onto their own line. However, if the input code has extra newlines, the formatter will retain them but will collapse more than one extra newline into a single one.This means that&lt;p&gt;Hello&lt;/p&gt; &lt;p&gt;Goodbye&lt;/p&gt;will be formatted as&lt;p&gt;Hello&lt;/p&gt; &lt;p&gt;Goodbye&lt;/p&gt;HTML attributes and component propsHTML attributes such as class in &lt;p class=&quot;container&quot;&gt; and component props such as name in &lt;Person name=&quot;Samantha&quot;&gt; are formatted to make use of Surface features.Inline literalsString literals are placed after the = without any interpolation brackets ({ }). This means that&lt;Component foo={&quot;hello&quot;} /&gt;will be formatted as&lt;Component foo=&quot;hello&quot; /&gt;Also, true boolean literals are formatted using the Surface shorthand whereby you can simply write the name of the attribute and it is passed in as true. For example,&lt;Component secure={true} /&gt;and&lt;Component secure=true /&gt;will both be formatted as&lt;Component secure /&gt;Interpolation ({ } brackets)Attributes that interpolate Elixir code with { } brackets are ran through the Elixir code formatter.This means that:&lt;Foo num={123456} /&gt; becomes &lt;Foo num={123_456} /&gt;list={[1,2,3]} becomes list={[1, 2, 3]}things={%{ one: &quot;1&quot;, two: &quot;2&quot;}} becomes things={%{one: &quot;1&quot;, two: &quot;2&quot;}}Sometimes the Elixir code formatter will add line breaks in the formatted expression. In that case, SurfaceFormatter will ensure indentation lines up. If there is a single attribute, it will keep the attribute on the same line as the tag name, for example:&lt;Component list={[ {&quot;foo&quot;, foo}, {&quot;bar&quot;, bar} ]} /&gt;However, if there are multiple attributes it will put them on separate lines:&lt;Child list={[ {&quot;foo&quot;, foo}, {&quot;bar&quot;, bar} ]} int={123} /&gt;Whitespace in string attributesCode semantics must be maintainedIt's critical that a code formatter never change the semantics of the code it modifies. In other words, the behavior of a program should never change due to a code formatter.The Whitespace section above outlines how SurfaceFormatter preserves code semantics by refusing to modify contents of &lt;script&gt;, &lt;code&gt; and &lt;pre&gt; tags as well as macro components. And for the same reason, the formatter does not introduce whitespace between HTML tags when there is none.Code semantics in string attributesThis principle is also relevant to string attributes, such as:&lt;MyComponent string_prop=&quot; string with whitespace &quot; /&gt;SurfaceFormatter cannot reliably guess whether application behavior will be changed by formatting the contents of a string. For example, consider a component with the following interface:&lt;List items=&quot; apples (fuji) oranges (navel) bell peppers (green) &quot; /&gt;The component internally splits on newline characters and outputs the following HTML:&lt;ul&gt; &lt;li&gt;apples (fuji)&lt;/li&gt; &lt;li&gt;oranges (navel)&lt;/li&gt; &lt;li&gt;bell peppers (green)&lt;/li&gt; &lt;/ul&gt;If SurfaceFormatter assumes it is safe to modify whitespace in string attributes, then the Surface code would likely change to this:&lt;List items=&quot;apples (fuji) oranges (navel) bell peppers (green)&quot; /&gt;Which would output the following HTML:&lt;ul&gt; &lt;li&gt;apples (fuji) oranges (navel) bell peppers (green)&lt;/li&gt; &lt;/ul&gt;Notice that the behavior of the application would have changed simply by running the formatter. It is for this reason that SurfaceFormatter always retains precisely the same whitespace in attribute strings, including both space and newline characters.Wrapping attributes on separate linesIn the Interpolation ({ } brackets) section we noted that attributes will each be put on their own line if there is more than one attribute and at least one contains a newline after being formatted by the Elixir code formatter.There is another scenario where attributes will each be given their own line: any time the opening tag would exceed line_length if put on one line. This value is provided in .formatter.exs and defaults to 98.The formatter indents attributes one tab in from the start of the opening tag for readability:&lt;div class=&quot;very long class value that causes this to exceed the established line length&quot; aria-role=&quot;button&quot; &gt;If you desire to have a separate line length for mix format and mix surface.format, provide surface_line_length in .formatter.exs and it will be given precedence when running mix surface.format. For example:# .formatter.exs [ surface_line_length: 120, import_deps: [...], # ... ]Developer ResponsibilityAs with all changes (for both mix format and mix surface.format) it's recommended that developers don't blindly run the formatter on an entire codebase and commit, but instead sanity check each file to ensure the results are desired.","ref":"Surface.Formatter.html#format_string!/2","title":"Surface.Formatter.format_string!/2","type":"function"},{"doc":"Returns true if the argument is an element (HTML element or surface component), false otherwise.","ref":"Surface.Formatter.html#is_element?/1","title":"Surface.Formatter.is_element?/1","type":"function"},{"doc":"Given a tag, return whether to render the contens verbatim instead of formatting them. Specifically, don't modify contents of macro components or &lt;pre&gt; and &lt;code&gt; tags.","ref":"Surface.Formatter.html#render_contents_verbatim?/1","title":"Surface.Formatter.render_contents_verbatim?/1","type":"function"},{"doc":"A parsed HTML/Component attribute name and value.","ref":"Surface.Formatter.html#t:attribute/0","title":"Surface.Formatter.attribute/0","type":"type"},{"doc":"The value of a parsed HTML/Component attribute.","ref":"Surface.Formatter.html#t:attribute_value/0","title":"Surface.Formatter.attribute_value/0","type":"type"},{"doc":"A node that will ultimately be sent to Surface.Formatter.Render.node/2 for rendering.The output of Surface.Compiler.Parser.parse is ran through the various formatting phases, which ultimately output a tree of this type.","ref":"Surface.Formatter.html#t:formatter_node/0","title":"Surface.Formatter.formatter_node/0","type":"type"},{"doc":"Options that can be passed to Surface.Formatter.format_string!/2.:line_length - Maximum line length before wrapping opening tags:indent - Starting indentation depth depending on the context of the ~F sigil","ref":"Surface.Formatter.html#t:option/0","title":"Surface.Formatter.option/0","type":"type"},{"doc":"A node output by Surface.Compiler.Parser.parse.","ref":"Surface.Formatter.html#t:surface_node/0","title":"Surface.Formatter.surface_node/0","type":"type"},{"doc":"The name of an HTML/Surface tag, such as div, ListItem, or #Markdown.","ref":"Surface.Formatter.html#t:tag/0","title":"Surface.Formatter.tag/0","type":"type"},{"doc":"Whitespace nodes that can be rendered by Surface.Formatter.Render.node/2.The Surface parser does not return these, but formatter phases introduce these nodes in preparation for rendering.:newline adds a newline (\\n) character:space adds a space () character:indent adds spaces at the appropriate indentation amount:indent_one_less adds spaces at 1 indentation level removed (used for closing tags)","ref":"Surface.Formatter.html#t:whitespace/0","title":"Surface.Formatter.whitespace/0","type":"type"},{"doc":"","ref":"Surface.Formatter.NodeTranslator.html","title":"Surface.Formatter.NodeTranslator","type":"module"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.context_for_block/3.","ref":"Surface.Formatter.NodeTranslator.html#context_for_block/3","title":"Surface.Formatter.NodeTranslator.context_for_block/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.context_for_node/3.","ref":"Surface.Formatter.NodeTranslator.html#context_for_node/3","title":"Surface.Formatter.NodeTranslator.context_for_node/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.context_for_subblock/4.","ref":"Surface.Formatter.NodeTranslator.html#context_for_subblock/4","title":"Surface.Formatter.NodeTranslator.context_for_subblock/4","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_attribute/5.","ref":"Surface.Formatter.NodeTranslator.html#handle_attribute/5","title":"Surface.Formatter.NodeTranslator.handle_attribute/5","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_block/6.","ref":"Surface.Formatter.NodeTranslator.html#handle_block/6","title":"Surface.Formatter.NodeTranslator.handle_block/6","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_block_expression/4.","ref":"Surface.Formatter.NodeTranslator.html#handle_block_expression/4","title":"Surface.Formatter.NodeTranslator.handle_block_expression/4","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_comment/3.","ref":"Surface.Formatter.NodeTranslator.html#handle_comment/3","title":"Surface.Formatter.NodeTranslator.handle_comment/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_expression/3.","ref":"Surface.Formatter.NodeTranslator.html#handle_expression/3","title":"Surface.Formatter.NodeTranslator.handle_expression/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_init/1.","ref":"Surface.Formatter.NodeTranslator.html#handle_init/1","title":"Surface.Formatter.NodeTranslator.handle_init/1","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_node/6.","ref":"Surface.Formatter.NodeTranslator.html#handle_node/6","title":"Surface.Formatter.NodeTranslator.handle_node/6","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_subblock/6.","ref":"Surface.Formatter.NodeTranslator.html#handle_subblock/6","title":"Surface.Formatter.NodeTranslator.handle_subblock/6","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_tagged_expression/4.","ref":"Surface.Formatter.NodeTranslator.html#handle_tagged_expression/4","title":"Surface.Formatter.NodeTranslator.handle_tagged_expression/4","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_text/2.","ref":"Surface.Formatter.NodeTranslator.html#handle_text/2","title":"Surface.Formatter.NodeTranslator.handle_text/2","type":"function"},{"doc":"","ref":"Surface.Formatter.NodeTranslator.html#to_meta/1","title":"Surface.Formatter.NodeTranslator.to_meta/1","type":"function"},{"doc":"A phase implementing a single &quot;rule&quot; for formatting code. These work as middleware between Surface.Compiler.Parser.parse and Surface.Formatter.Render.node/2 to modify node lists before they are rendered.Some phases rely on other phases; @moduledocs should make this explicit.For reference, the formatter operates by running these phases in the following order:Surface.Formatter.Phases.TagWhitespaceSurface.Formatter.Phases.NewlinesSurface.Formatter.Phases.SpacesToNewlinesSurface.Formatter.Phases.IndentSurface.Formatter.Phases.FinalNewlineSurface.Formatter.Phases.BlockExceptionsSurface.Formatter.Phases.Render","ref":"Surface.Formatter.Phase.html","title":"Surface.Formatter.Phase","type":"behaviour"},{"doc":"The function implementing the phase. Returns the given nodes with the transformation applied.","ref":"Surface.Formatter.Phase.html#c:run/2","title":"Surface.Formatter.Phase.run/2","type":"callback"},{"doc":"Given a list of nodes, find all &quot;element&quot; nodes (HTML elements or Surface components) and transform children of those nodes using the given function.Useful for recursing deeply through the entire tree of nodes.","ref":"Surface.Formatter.Phase.html#transform_element_children/2","title":"Surface.Formatter.Phase.transform_element_children/2","type":"function"},{"doc":"Given a list of nodes, find all &quot;element&quot; nodes (HTML elements or Surface components) and transform children of those nodes using the given function.Recurses deeply through the tree, unlike transform_element_children, which only affects a single layer.","ref":"Surface.Formatter.Phase.html#transform_elements_and_descendants/2","title":"Surface.Formatter.Phase.transform_elements_and_descendants/2","type":"function"},{"doc":"A node that takes a list of nodes and returns them back after applying a transformation","ref":"Surface.Formatter.Phase.html#t:node_transformer/0","title":"Surface.Formatter.Phase.node_transformer/0","type":"type"},{"doc":"A list of nodes","ref":"Surface.Formatter.Phase.html#t:nodes/0","title":"Surface.Formatter.Phase.nodes/0","type":"type"},{"doc":"Handle exceptional case for blocks.","ref":"Surface.Formatter.Phases.BlockExceptions.html","title":"Surface.Formatter.Phases.BlockExceptions","type":"module"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.BlockExceptions.html#run/2","title":"Surface.Formatter.Phases.BlockExceptions.run/2","type":"function"},{"doc":"","ref":"Surface.Formatter.Phases.BlockExceptions.html#transform_block/1","title":"Surface.Formatter.Phases.BlockExceptions.transform_block/1","type":"function"},{"doc":"Add a newline after all of the nodes","ref":"Surface.Formatter.Phases.FinalNewline.html","title":"Surface.Formatter.Phases.FinalNewline","type":"module"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.FinalNewline.html#run/2","title":"Surface.Formatter.Phases.FinalNewline.run/2","type":"function"},{"doc":"Adds indentation nodes (:indent and :indent_one_less) where appropriate.Surface.Formatter.Render.node/2 is responsible for adding the appropriate level of indentation. It keeps track of the indentation level based on how &quot;nested&quot; a node is. While running Formatter Phases, it's not necessary to keep track of that detail.:indent_one_less exists to notate the indentation that should occur before a closing tag, which is one less than its children.Relies on Newlines phase, which collapses :newline nodes to at most 2 in a row.","ref":"Surface.Formatter.Phases.Indent.html","title":"Surface.Formatter.Phases.Indent","type":"module"},{"doc":"","ref":"Surface.Formatter.Phases.Indent.html#add_indentation/2","title":"Surface.Formatter.Phases.Indent.add_indentation/2","type":"function"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.Indent.html#run/2","title":"Surface.Formatter.Phases.Indent.run/2","type":"function"},{"doc":"Standardizes usage of newlines.Prevents more than 1 empty line in a row.Prevents an empty line separating an opening/closing tag from the contents inside.","ref":"Surface.Formatter.Phases.Newlines.html","title":"Surface.Formatter.Phases.Newlines","type":"module"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.Newlines.html#run/2","title":"Surface.Formatter.Phases.Newlines.run/2","type":"function"},{"doc":"Render the formatted Surface code after it has run through the other transforming phases.","ref":"Surface.Formatter.Phases.Render.html","title":"Surface.Formatter.Phases.Render","type":"module"},{"doc":"Given a Surface.Formatter.formatter_node/0 node, render it to a string for writing back into a file.","ref":"Surface.Formatter.Phases.Render.html#render_node/2","title":"Surface.Formatter.Phases.Render.render_node/2","type":"function"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.Render.html#run/2","title":"Surface.Formatter.Phases.Render.run/2","type":"function"},{"doc":"","ref":"Surface.Formatter.Phases.Render.html#t:render_attribute_option/0","title":"Surface.Formatter.Phases.Render.render_attribute_option/0","type":"type"},{"doc":"In a variety of scenarios, converts :space nodes to :newline nodes.(Below, &quot;element&quot; means an HTML element or a Surface component.)If an element contains other elements as children, surround it with newlines.If there is a space after an opening tag or before a closing tag, convert it to a newline.If there is a closing tag on its own line, ensure there's a newline before the next sibling node.","ref":"Surface.Formatter.Phases.SpacesToNewlines.html","title":"Surface.Formatter.Phases.SpacesToNewlines","type":"module"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.SpacesToNewlines.html#run/2","title":"Surface.Formatter.Phases.SpacesToNewlines.run/2","type":"function"},{"doc":"Inspects all text nodes and &quot;tags&quot; leading and trailing whitespace by converting it into a :space atom or a list of :newline atoms.This is the first phase of formatting, and all other phases depend on it.","ref":"Surface.Formatter.Phases.TagWhitespace.html","title":"Surface.Formatter.Phases.TagWhitespace","type":"module"},{"doc":"Callback implementation for Surface.Formatter.Phase.run/2.","ref":"Surface.Formatter.Phases.TagWhitespace.html#run/2","title":"Surface.Formatter.Phases.TagWhitespace.run/2","type":"function"},{"doc":"This function takes a node provided by Surface.Compiler.Parser.parse and converts the leading/trailing whitespace into Surface.Formatter.whitespace/0 nodes.","ref":"Surface.Formatter.Phases.TagWhitespace.html#tag_whitespace/1","title":"Surface.Formatter.Phases.TagWhitespace.tag_whitespace/1","type":"function"},{"doc":"An Elixir formatter plugin for Surface code.Elixir 1.13 introduced formatter plugins, allowing the Surface formatter to run during mix format instead of requiring developers to run mix surface.format separately.To format Surface code using Elixir 1.12 or earlier, use mix surface.format..formatter.exs setupAdd to :plugins in .formatter.exs in order to format ~F sigils and .sface files when running mix format.Only works on files matching patterns in :inputs, so add patterns for all Surface files to ensure they're formatted.# in .formatter.exs [ ..., plugins: [Surface.Formatter.Plugin] # add patterns matching all .sface files and all .ex files with ~F sigils inputs: [&quot;*.{ex,exs}&quot;, &quot;{config,lib,test}/**/*.{ex,exs,sface}&quot;], # THE FOLLOWING ARE OPTIONAL: # set desired line length for both Elixir&#39;s code formatter and this one # (only affects opening tags in Surface) line_length: 80, # or, set line length only for Surface code (overrides `line_length`) surface_line_length: 84 ]OptionsIn .formatter.exs, the following options can be provided::line_length - Maximum line length of an opening tag before SurfaceFormatter attempts to wrap it onto multiple lines. This option is used by Code.format_string!/2 and mix format and defaults to 98.:surface_line_length - Overrides :line_length; useful for setting separate desired line length for Surface code and non-Surface Elixir code.","ref":"Surface.Formatter.Plugin.html","title":"Surface.Formatter.Plugin","type":"module"},{"doc":"Callback implementation for Mix.Tasks.Format.features/1.","ref":"Surface.Formatter.Plugin.html#features/1","title":"Surface.Formatter.Plugin.features/1","type":"function"},{"doc":"Callback implementation for Mix.Tasks.Format.format/2.","ref":"Surface.Formatter.Plugin.html#format/2","title":"Surface.Formatter.Plugin.format/2","type":"function"},{"doc":"SurfaceFormatter A code formatter for https://hex.pm/packages/surface.The complete documentation for SurfaceFormatter is located here.","ref":"readme.html","title":"SurfaceFormatter","type":"extras"},{"doc":"Add :surface_formatter as a dependency in mix.exs:defp deps do [ {:surface_formatter, &quot;~&gt; 0.7.4&quot;} ] end","ref":"readme.html#installation","title":"SurfaceFormatter - Installation","type":"extras"},{"doc":"ConfigurationModify the following in .formatter.exs:inputs - add patterns for all Surface filesplugins - add Surface.Formatter.Plugin# .formatter.exs [ ..., # match all .sface files and all .ex files with ~F sigils inputs: [&quot;lib/**/*.{ex,sface}&quot;, ...], plugins: [Surface.Formatter.Plugin] ]For documentation of other .formatter.exs options, see Surface.Formatter.Plugin.Usage$ mix format(Formats both Elixir and Surface code.)","ref":"readme.html#formatter-plugin-usage-elixir-1-13-and-later","title":"SurfaceFormatter - Formatter Plugin Usage (Elixir 1.13 and later)","type":"extras"},{"doc":"ConfigurationAdd surface_inputs to .formatter.exs with patterns for all Surface files:# .formatter.exs [ ..., # match all .sface files and all .ex files with ~F sigils surface_inputs: [&quot;lib/**/*.{ex,sface}&quot;, ...] ]If your project does not use sface files, you can omit :surface_inputs and specify file patterns in the standard :inputs field instead. (mix surface.format will fall back to :inputs.) But be warned that including .sface files in :inputs causes mix format to crash in Elixir 1.12 and earlier.For documentation of other .formatter.exs options, see mix surface.format.Usage$ mix surface.format","ref":"readme.html#mix-task-usage-elixir-1-12-and-earlier","title":"SurfaceFormatter - Mix Task Usage (Elixir 1.12 and earlier)","type":"extras"},{"doc":"The formatter mostly follows these rules:Only formats code inside of ~F&quot;&quot;&quot; blocks and .sface files.Child nodes are typically indented 2 spaces in from their parent.Interpolated Elixir code (inside { } brackets) is formatted by the official Elixir formatter.HTML attributes are put on separate lines if the line is too long.Retains &quot;lack of whitespace&quot; such as &lt;p&gt;No whitespace between text and tags&lt;/p&gt;.Collapses extra newlines down to at most one blank line.See Surface.Formatter.format_string!/2 for further documentation.","ref":"readme.html#formatting-rules","title":"SurfaceFormatter - Formatting rules","type":"extras"},{"doc":"Out of the box, Surface code that looks like this: &lt;RootComponent with_many_attributes={ true } causing_this_line_to_wrap={ true} because_it_is_too_long={ &quot;yes, this line is long enough to wrap&quot; }&gt; &lt;!-- HTML public comment (hits the browser) --&gt; {!-- Surface private comment (does not hit the browser) --} &lt;div :if={ @show_div } class=&quot;container&quot;&gt; &lt;p&gt; Text inside paragraph &lt;/p&gt; &lt;span&gt;Text touching parent tags&lt;/span&gt; &lt;/div&gt; &lt;Child items={[%{name: &quot;Option 1&quot;, key: 1}, %{name: &quot;Option 2&quot;, key: 2}, %{name: &quot;Option 3&quot;, key: 3}, %{name: &quot;Option 4&quot;, key: 4}]}&gt; Default slot contents &lt;/Child&gt; &lt;/RootComponent&gt;will be formatted like this:&lt;RootComponent with_many_attributes causing_this_line_to_wrap because_it_is_too_long=&quot;yes, this line is long enough to wrap&quot; &gt; &lt;!-- HTML public comment (hits the browser) --&gt; {!-- Surface private comment (does not hit the browser) --} &lt;div :if={@show_div} class=&quot;container&quot;&gt; &lt;p&gt; Text inside paragraph &lt;/p&gt; &lt;span&gt;Text touching parent tags&lt;/span&gt; &lt;/div&gt; &lt;Child items={[ %{name: &quot;Option 1&quot;, key: 1}, %{name: &quot;Option 2&quot;, key: 2}, %{name: &quot;Option 3&quot;, key: 3}, %{name: &quot;Option 4&quot;, key: 4} ]}&gt; Default slot contents &lt;/Child&gt; &lt;/RootComponent&gt;","ref":"readme.html#example-at-a-glance","title":"SurfaceFormatter - Example at a glance","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Handle arbitrary expressions when checking for newlines in strings","ref":"changelog.html#v0-7-4-2021-12-20","title":"Changelog - v0.7.4 (2021-12-20)","type":"extras"},{"doc":"Stop endlessly indenting strings with newlines in expression attributes (#54)","ref":"changelog.html#v0-7-3-2021-12-18","title":"Changelog - v0.7.3 (2021-12-18)","type":"extras"},{"doc":"Fix crash with Elixir expression {...} on Elixir 1.13 without :line_length or :surface_line_length (#53)","ref":"changelog.html#v0-7-2-2021-12-03","title":"Changelog - v0.7.2 (2021-12-03)","type":"extras"},{"doc":"Stop adding spaces to indent blank lines in expressions (#51)","ref":"changelog.html#v0-7-1-2021-11-29","title":"Changelog - v0.7.1 (2021-11-29)","type":"extras"},{"doc":"Add Surface.Formatter.Plugin for Elixir 1.13 Formatter Plugin support.","ref":"changelog.html#v0-7-0-2021-11-22","title":"Changelog - v0.7.0 (2021-11-22)","type":"extras"},{"doc":"Support tagged expression attributes referencing variables (#47)Require Surface ~&gt; 0.5 instead of ~&gt; 0.5.0 to expand compatibility to 0.6","ref":"changelog.html#v0-6-0-2021-10-21","title":"Changelog - v0.6.0 (2021-10-21)","type":"extras"},{"doc":"Stop endlessly indenting attribute strings with interpolation whenever node is indented (#43)","ref":"changelog.html#v0-5-4-2021-08-31","title":"Changelog - v0.5.4 (2021-08-31)","type":"extras"},{"doc":"Stop endlessly indenting attribute strings with interpolation (#41)","ref":"changelog.html#v0-5-3-2021-08-30","title":"Changelog - v0.5.3 (2021-08-30)","type":"extras"},{"doc":"Enable reading from stdin (#37)Stop turning :if={true} into :if (#39)Stop endlessly indenting strings with newlines in list attributes (#40)","ref":"changelog.html#v0-5-2-2021-08-27","title":"Changelog - v0.5.2 (2021-08-27)","type":"extras"},{"doc":"Fix crash with {#match &quot;string&quot;} scenario (#32)Stop removing {/unless} (#33)Stop formatting contents of &lt;script&gt; tags (#34)Stop performing conversion of pre-0.5 &lt;template&gt; and &lt;slot&gt; to &lt;#template&gt; and &lt;#slot&gt; (#35)","ref":"changelog.html#v0-5-1-2021-07-06","title":"Changelog - v0.5.1 (2021-07-06)","type":"extras"},{"doc":"Support new Surface syntax (#21 and #22)","ref":"changelog.html#v0-5-0-2021-06-17","title":"Changelog - v0.5.0 (2021-06-17)","type":"extras"},{"doc":"Fix crash related to HTML comments &lt;!-- --&gt; (#17)","ref":"changelog.html#v0-4-1-2021-05-13","title":"Changelog - v0.4.1 (2021-05-13)","type":"extras"},{"doc":"Require Surface v0.4.0 (#16)","ref":"changelog.html#v0-4-0-2021-05-06","title":"Changelog - v0.4.0 (2021-05-06)","type":"extras"},{"doc":"Require Surface v0.3.2 (#15)","ref":"changelog.html#v0-3-2-2021-05-06","title":"Changelog - v0.3.2 (2021-05-06)","type":"extras"},{"doc":"Require Surface v0.3.1 (#13)Update list of void elements per Surface v0.3.1 (#14)","ref":"changelog.html#v0-3-1-2021-03-06","title":"Changelog - v0.3.1 (2021-03-06)","type":"extras"},{"doc":"Require Surface v0.3.0 (#11)Do not add trailing slash in void elements without a closing tag (#12)","ref":"changelog.html#v0-3-0-2021-03-02","title":"Changelog - v0.3.0 (2021-03-02)","type":"extras"},{"doc":"Fix crash whenever bracket-less keyword lists in attributes contained an interpolation in a key (#9)","ref":"changelog.html#v0-2-2-2021-02-17","title":"Changelog - v0.2.2 (2021-02-17)","type":"extras"},{"doc":"Allow inline elements on the same line with text nodes (#5)Fix issue where extra newlines surrounding text nodes were removed (#7)Organize transformations in formal phases (#8)Stop moving every child onto its own line; replace with limited rules for when to do that (#8)","ref":"changelog.html#v0-2-1-2021-02-17","title":"Changelog - v0.2.1 (2021-02-17)","type":"extras"},{"doc":"Require Surface v0.2.0 (#2)","ref":"changelog.html#v0-2-0-2021-01-28","title":"Changelog - v0.2.0 (2021-01-28)","type":"extras"},{"doc":"Fix crash for self-closing &lt;pre&gt;, &lt;code&gt;, and &lt;#Macro&gt; tags. (#1)Fix crash when &lt;pre&gt;, &lt;code&gt;, and &lt;#Macro&gt; tags contained components, HTML elements, or interpolations. (#3)","ref":"changelog.html#v0-1-1-2021-01-28","title":"Changelog - v0.1.1 (2021-01-28)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2021-01-25","title":"Changelog - v0.1.0 (2021-01-25)","type":"extras"}]